#include <vector>
#include <iostream> 
#include <queue>
#include <tuple>
using namespace std;

// type alias-uri
using VI  = vector<int>;
using VVI = vector<VI>;     // tipul matrice de int
using VC  = vector<char>;
using VVC = vector<VC>;     // matrice de caractere
using TI  = tuple<int, int, int>;

const int Inf = 0x3f3f3f3f,
	      di[] = {-1, 0, 1, 0},
	      dj[] = {0, 1, 0, -1};
	      
// matrici vide!
VVI a;   // matricea de valori care se citesc
VVI c;   // c[i][j] = distanta minima (nr minim de pasi)
                   // de la (ip, jp) la (i, j)
int n, X, Y, Z, T;

void CitesteDate();
void Lee(int ip, int jp, VVI& c); // obligatoriu c este prin referinta!
bool Ok(int i, int j);

int main()
{
	CitesteDate();
	Lee(1, 1, c);
	
	cout << c[n][n] << '\n';
}

// directive de Precompilare
#define iv (i + di[d])
#define jv (j + dj[d])

// O(n * m)
void Lee(int ip, int jp, VVI& c)
{
	priority_queue<TI, vector<TI>, greater<TI>> Q; // min-heap
	
	c = VVI(n + 1, VI(n + 1, Inf)); // aici se creaza matricea!
	
    // plasam celula de plecare in coada
	c[ip][jp] = a[ip][jp]; 
	Q.emplace(c[ip][jp], ip, jp);
	
	int cost, i, j;
	while (!Q.empty())  // cat timp coada nu este vida
	{
		tie(cost, i, j) = Q.top();
		Q.pop();       // Stergem primul element din coada 
		
		if (cost > c[i][j]) // IMPORTANT!
			continue;
			
		for (int d = 0; d < 4; ++d)
			if (Ok(iv,jv) && c[iv][jv] > c[i][j] + a[iv][jv])
			{
				c[iv][jv] = c[i][j] + a[iv][jv];
				Q.emplace(c[iv][jv], iv, jv);   
			}
	}
}

bool Ok(int i, int j)
{
	if (i < 1 || i > n || j < 1 || j > n) // in afara matricei
		return false;
		
	return true;
}

void CitesteDate()
{
	cin >> n >> X >> Y >> Z >> T;
	
	a = VVI(n + 1, VI(n + 2)); // a sa existe coloana n
	
	for (int j = 1; j <= n; ++j)
			cin >> a[1][j];
			
	for (int i = 2; i <= n; ++i)
		for (int j = 1; j <= n; ++j)
			a[i][j] = 1 + (a[i-1][j-1] * X + a[i-1][j] * Y + a[i-1][j+1] * Z) % T;
}






