#include <vector>
#include <iostream> 
#include <queue>
#include <tuple>
#include <string>
#include <algorithm>
#include <set>
using namespace std;

void Print1(set<string>& s)
{
	for (auto x : s)
		cout << x << ' ';
	cout << '\n';
}

void Print2(set<string>& s)
{
	for (auto it = s.begin(); it != s.end(); ++it)
		cout << *it << ' ';
	cout << '\n';
}

int main()
{
	/* Operatiile: 
	 * - find(x)
	 * - erase(it)
	 * - insert(x)
	 * 
	 * au complexitatea O(log2(size)) 
	 */ 
	 
	set<string> s;
	
	s.insert("Nicu"); // O(log2(size))
	s.insert("Radu");
	s.insert("Ioana");
	s.insert("Ana");
	
	s.erase("Radu"); // sterge cheia "Radu"
	Print1(s);
	
	s.erase(s.begin()); // sterge elem indicat de un iterator
	Print1(s);
}

